//***********************************************************
//** This source code is provided "AS IS" with no warranties, 
//** and confers no rights.
//** Author:	Kallely L Sajan (sajankl@hotmail.com)
//***********************************************************

//** Include the standard header files here
//** #include "stdafx.h"
//** #include < windows.h >
//** #include < msi.h >
//** #include < msiquery.h >

//***********************************************************
//** Call back function for EnumChildWindows()
//**---------------------------------------------------------
//** Author:	Kallely L Sajan (sajankl@hotmail.com)
//***********************************************************
BOOL CALLBACK EnumChildProc(HWND hwnd,LPARAM lParam)
{
  TCHAR buf[100];

  GetClassName( hwnd, (LPTSTR)&buf, 100 );
  if ( _tcscmp( buf, _T("RichEdit20W") ) == 0 )
  {
   *(HWND*)lParam = hwnd;
   return FALSE;
  }
  return TRUE;
}


//***********************************************************
//** Custom action to check if the license is completly 
//** viewed. 
//**---------------------------------------------------------
//** Return values:
//** 	(1) Always returns success
//**    (2) Sets the private property LicenseViewed when 
//**        the text is scrolled to near end.
//**---------------------------------------------------------
//** Usage:
//** 	(1) Change "MyProduct Installer" to the window title 
//**	    of the license agreement window
//**	(2) In the license agreement dialog, on the scrollable 
//** 	    text control event, call the custom action 
//** 	    CheckLicenseViewed using a DoAction
//** 	(3) For the Next button, modify the Enable 
//** 	    ControlCondition to include the property 
//** 	    LicenseViewed
//**---------------------------------------------------------
//** Author:	Kallely L Sajan (sajankl@hotmail.com)
//***********************************************************
UINT __stdcall CheckLicenseViewed(MSIHANDLE hMSI)
{
	HWND hWnd;
	HWND hWndChild=NULL;

	if (MsiEvaluateCondition(hMSI,"LicenseViewed")==MSICONDITION_FALSE) {
		hWnd = FindWindow(NULL, "MyProduct Installer");
		if (hWnd) {
			EnumChildWindows( hWnd, EnumChildProc, (LPARAM)&hWndChild );
			if ( hWndChild ) {
				SCROLLINFO sinfo;
				sinfo.cbSize=sizeof(sinfo);
				sinfo.fMask=SIF_TRACKPOS | SIF_RANGE | SIF_POS | SIF_PAGE;
				GetScrollInfo(hWndChild, SB_VERT, &sinfo);
				//max range depends on page size
				UINT MaxScrollPos = sinfo.nMax  - (sinfo.nPage - 1) ;
				//max less, say 5 - an allowable max.
				MaxScrollPos = MaxScrollPos - 5;

				if (sinfo.nTrackPos  > MaxScrollPos) {
					MsiSetProperty(hMSI, TEXT("LicenseViewed"), TEXT("1"));
				}
				else
					MsiSetProperty(hMSI, TEXT("LicenseViewed"), NULL);
			}
		}
	}
	return ERROR_SUCCESS;
}
//***********************************************************